local B, L, T = unpack(select(2, ...))


-- key binding interface constants
BINDING_HEADER_BW = "Bank's Watch"
BINDING_NAME_BW_TOGGLE = L[10020]
BINDING_NAME_BW_TOGGLETRACKER = L[10056]
BINDING_NAME_BW_BANK = L[10022]
BINDING_NAME_BW_REAGENT = L[10023]
BINDING_NAME_BW_CHARACTER = L[10024]
BINDING_NAME_BW_VOID = L[10025]
BINDING_NAME_BW_GUILD = L[10026]
_G["BINDING_NAME_CLICK BWartifact:LeftButtonDown"] = L[10021].." "..ARTIFACT_POWER

B.C = {}
function B.C.Create()
    -- http://wowwiki.wikia.com/wiki/Using_the_Interface_Options_Addons_panel
    local addon = {}
    
    addon.panel = CreateFrame("Frame", "BWPanel", UIParent)
    -- Register in the Interface Addon Options GUI
    -- Set the name for the Category for the Options Panel
    addon.panel.name = "Bank's Watch"
    addon.panel.title = addon.panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    addon.panel.title:SetFont(addon.panel.title:GetFont(), 16) -- Resize string
    addon.panel.title:SetText("Bank's Watch")
    addon.panel.title:SetPoint("TOPLEFT", 15, -25)

    addon.panel.support = addon.panel:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
    addon.panel.support:SetPoint("TOPLEFT", addon.panel.title, "BOTTOMLEFT", 0, -10)
    addon.panel.support:SetText(L[10028])
    addon.panel.support:SetTextColor(1, 1, 1)

    -- Add the panel to the Interface Options
    addon.panel.iconsize = B.C.iconsizeslider(addon.panel)
    addon.panel.iconrow = B.C.iconrowslider(addon.panel)
    addon.panel.reload = B.C.reloaduibutton(addon.panel, L[10029])
    addon.panel.minimize = B.C.minimizecheckbox(addon.panel)
    addon.panel.openbank = B.C.openbankcheckbox(addon.panel)
    addon.panel.openplayer = B.C.openplayercheckbox(addon.panel)

    -- Create tabs (color picker and label)
    addon.panel.colorsection = B.C.colorselect(addon.panel)

    addon.panel.default = B.C.ConfigToDefault
    InterfaceOptions_AddCategory(addon.panel)
end

function B.C.ResetColor(r, g, b, a, colorTable, label, option, button)

    colorTable.r = r; colorTable.g = g; colorTable.b = b; colorTable.a = a

    BWsavedtable['color'..option..'label'] = nil
    BWsavedtable['color'..option] = nil
    _G['BW'..option..'coloroption']:SetBackdropColor(colorTable.r, colorTable.g, colorTable.b, colorTable.a)
    _G['BW'..option..'coloroption'].editbox:SetText(label)
    button:SetText("|cffffffff"..label.."|r")
    button:SetBackdropColor(colorTable.r, colorTable.g,colorTable.b, colorTable.a)
end

function B.C.ConfigToDefault()

    _G['BWiconsizeslider']:SetValue(32)
    _G['BWiconrowslider']:SetValue(12)
    _G['BWminimizecheckbox']:SetChecked(false)
    BWsavedtable['minimize'] = false

    T.LABEL['bank'] = L[10001]
    B.C.ResetColor(0.32, 0.15, 0.64, 1, T.BANKTAB, T.LABEL['bank'], "bank", T.F.mainframe.bankbutton)

    T.LABEL['reagent'] = L[10002]
    B.C.ResetColor(0.34, 0.24, 0.49, 1, T.REAGENTTAB, T.LABEL['reagent'], "reagent", T.F.mainframe.reagentbutton)

    T.LABEL['player'] = L[10010]
    B.C.ResetColor(0.39, 0.24, 0.81, 1, T.CHARTAB, T.LABEL['player'], "character", T.F.mainframe.characterbutton)

    T.LABEL['void'] = L[10003]
    B.C.ResetColor(0.24, 0.24, 0.49, 1, T.VOIDTAB, T.LABEL['void'], "void", T.F.mainframe.voidbutton)

    T.LABEL['guild'] = L[10004]
    B.C.ResetColor(0.20, 0.17, 0.56, 1, T.GUILDTAB, T.LABEL['guild'], "guild", T.F.mainframe.guildbutton)

    T.TOOLTIP.r = ITEM_QUALITY_COLORS[6].r; T.TOOLTIP.g = ITEM_QUALITY_COLORS[6].g; T.TOOLTIP.b = ITEM_QUALITY_COLORS[6].b
    BWsavedtable['colortooltip'] = nil
    _G['BWtooltipcoloroption']:SetBackdropColor(T.TOOLTIP.r, T.TOOLTIP.g, T.TOOLTIP.b)

    T.TOOLTIPAC.r = ITEM_QUALITY_COLORS[5].r; T.TOOLTIPAC.g = ITEM_QUALITY_COLORS[5].g; T.TOOLTIPAC.b = ITEM_QUALITY_COLORS[5].b
    BWsavedtable['colortooltipaccent'] = nil
    _G['BWtooltipaccentcoloroption']:SetBackdropColor(T.TOOLTIPAC.r, T.TOOLTIPAC.g, T.TOOLTIPAC.b)
end

function B.C.LoadSettings()

    if BWsavedtable then
        T.BUTTON_HEIGHT = BWsavedtable['iconsize'] or 32
        T.ROW = BWsavedtable['iconrow'] or 12

        if BWsavedtable['minimize'] then T.F.mainframe.togglebutton:Show() end
        if not BWsavedtable['bankbagstoggle'] then T.F.mainframe.bank.bags:Hide() end
        if not BWsavedtable['playerbagstoggle'] then T.F.mainframe.character.bags:Hide() end

        if BWsavedtable['colorbank'] then
            T.BANKTAB.r, T.BANKTAB.g, T.BANKTAB.b, T.BANKTAB.a = unpack(BWsavedtable['colorbank'])
            T.F.mainframe.bankbutton:SetBackdropColor(T.BANKTAB.r, T.BANKTAB.g, T.BANKTAB.b, T.BANKTAB.a)
        end
        if BWsavedtable['colorbanklabel'] then
            T.LABEL['bank'] = BWsavedtable['colorbanklabel']
            T.F.mainframe.bankbutton:SetText("|cffffffff"..BWsavedtable['colorbanklabel'].."|r")
        end

        if BWsavedtable['colorreagent'] then
            T.REAGENTTAB.r, T.REAGENTTAB.g, T.REAGENTTAB.b, T.REAGENTTAB.a = unpack(BWsavedtable['colorreagent'])
            T.F.mainframe.reagentbutton:SetBackdropColor(T.REAGENTTAB.r, T.REAGENTTAB.g, T.REAGENTTAB.b, T.REAGENTTAB.a)
        end
        if BWsavedtable['colorreagentlabel'] then
            T.LABEL['reagent'] = BWsavedtable['colorreagentlabel']
            T.F.mainframe.reagentbutton:SetText("|cffffffff"..BWsavedtable['colorreagentlabel'].."|r")
        end

        if BWsavedtable['colorcharacter'] then
            T.CHARTAB.r, T.CHARTAB.g, T.CHARTAB.b, T.CHARTAB.a = unpack(BWsavedtable['colorcharacter'])
            T.F.mainframe.characterbutton:SetBackdropColor(T.CHARTAB.r, T.CHARTAB.g, T.CHARTAB.b, T.CHARTAB.a)
        end
        if BWsavedtable['colorcharacterlabel'] then
            T.LABEL['player'] = BWsavedtable['colorcharacterlabel']
            T.F.mainframe.characterbutton:SetText("|cffffffff"..BWsavedtable['colorcharacterlabel'].."|r")
        end

        if BWsavedtable['colorvoid'] then
            T.VOIDTAB.r, T.VOIDTAB.g, T.VOIDTAB.b, T.VOIDTAB.a = unpack(BWsavedtable['colorvoid'])
            T.F.mainframe.voidbutton:SetBackdropColor(T.VOIDTAB.r, T.VOIDTAB.g, T.VOIDTAB.b, T.VOIDTAB.a)
        end
        if BWsavedtable['colorvoidlabel'] then
            T.LABEL['void'] = BWsavedtable['colorvoidlabel']
            T.F.mainframe.voidbutton:SetText("|cffffffff"..BWsavedtable['colorvoidlabel'].."|r")
        end

        if BWsavedtable['colorguild'] then
            T.GUILDTAB.r, T.GUILDTAB.g, T.GUILDTAB.b, T.GUILDTAB.a = unpack(BWsavedtable['colorguild'])
            T.F.mainframe.guildbutton:SetBackdropColor(T.GUILDTAB.r, T.GUILDTAB.g, T.GUILDTAB.b, T.GUILDTAB.a)
        end
        if BWsavedtable['colorguildlabel'] then
            T.LABEL['guild'] = BWsavedtable['colorguildlabel']
            T.F.mainframe.guildbutton:SetText("|cffffffff"..BWsavedtable['colorguildlabel'].."|r")
        end

        if BWsavedtable['colortooltip'] then
            T.TOOLTIP.r, T.TOOLTIP.g, T.TOOLTIP.b, T.TOOLTIP.a = unpack(BWsavedtable['colortooltip'])
        end

        if BWsavedtable['colortooltipaccent'] then
            T.TOOLTIPAC.r, T.TOOLTIPAC.g, T.TOOLTIPAC.b, T.TOOLTIPAC.a = unpack(BWsavedtable['colortooltipaccent'])
        end
    end
end

function B.C.iconsizeslider(parent)

    local BWslider = CreateFrame("Slider", "BWiconsizeslider", parent, "OptionsSliderTemplate")
    BWslider:SetWidth(200)
    BWslider:SetHeight(16)
    BWslider:SetPoint("TOPLEFT", 25, -100)
    BWiconsizesliderLow:SetText("25")
    BWiconsizesliderHigh:SetText("40")
    BWslider:SetMinMaxValues(25, 40)
    BWslider:SetValueStep(1)
    BWslider:SetValue(BWsavedtable['iconsizeslider'] and tonumber(BWsavedtable['iconsizeslider']) or 32)
    BWiconsizesliderText:SetFormattedText(L[10030]..": %d ("..CHAT_DEFAULT..": 32)", BWslider:GetValue())
    BWslider:SetScript("OnValueChanged", function(self, value)
        BWiconsizesliderText:SetFormattedText(L[10030]..": %d ("..CHAT_DEFAULT..": 32)", value)
        BWsavedtable['iconsize'] = math.floor(value + 0.5)
        BWsavedtable['iconsizeslider'] = value
    end)
    return BWslider
end

function B.C.iconrowslider(parent)

    local BWslider = CreateFrame("Slider", "BWiconrowslider", parent, "OptionsSliderTemplate")
    BWslider:SetWidth(200)
    BWslider:SetHeight(16)
    BWslider:SetPoint("TOPLEFT", 25, -150)
    BWiconrowsliderLow:SetText("10")
    BWiconrowsliderHigh:SetText("20")
    BWslider:SetMinMaxValues(10, 20)
    BWslider:SetValueStep(1)
    BWslider:SetValue(BWsavedtable['iconrowslider'] and tonumber(BWsavedtable['iconrowslider']) or 12)
    BWiconrowsliderText:SetFormattedText(L[10031]..": %d ("..CHAT_DEFAULT..": 12)", BWslider:GetValue())
    BWslider:SetScript("OnValueChanged", function(self, value)
        BWiconrowsliderText:SetFormattedText(L[10031]..": %d ("..CHAT_DEFAULT..": 12)", value)
        BWsavedtable['iconrow'] = math.floor(value + 0.5)
        BWsavedtable['iconrowslider'] = value
    end)
    return BWslider
end

function B.C.reloaduibutton(parent, text)

    local label = parent:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
    label:SetPoint("TOPLEFT", parent, 25, -200)
    label:SetText("*"..L[10032])
    label:SetTextColor(1, 0, 0)

    local button = CreateFrame("Button", nil, parent, "UIPanelbuttontemplate")
    button:SetText(text)
    button:SetWidth(100)
    button:SetHeight(32)
    button:SetPoint("TOPLEFT", 25, -215)
    button.label = label

    button:SetScript("OnClick", function(self) ReloadUI() end)
    B.I.GradientButton.Create(button, "VERTICAL")
    return button
end

function B.C.minimizecheckbox(parent)

    local checkbox = CreateFrame("CheckButton", "BWminimizecheckbox", parent, "InterfaceOptionsCheckButtonTemplate")
    checkbox:SetPoint("TOPLEFT", 23, -270)
    checkbox:SetHitRectInsets(0, -300, 0, 0)
    BWminimizecheckboxText:SetText(L[10033])
    checkbox:SetChecked(BWsavedtable['minimize'] or false)
    checkbox:SetScript("OnClick", function(self) 
        if self:GetChecked() then
            BWsavedtable['minimize'] = true
        else
            BWsavedtable['minimize'] = false
        end
    end)
    return checkbox
end

function B.C.openbankcheckbox(parent)

    local checkbox = CreateFrame("CheckButton", "BWopenbankcheckbox", parent, "InterfaceOptionsCheckButtonTemplate")
    checkbox:SetPoint("TOPLEFT", 23, -295)
    checkbox:SetHitRectInsets(0, -300, 0, 0)
    BWopenbankcheckboxText:SetText(L[10036])
    checkbox:SetChecked(BWsavedtable['openbank'] or false)
    checkbox:SetScript("OnClick", function(self) 
        if self:GetChecked() then
            BWsavedtable['openbank'] = true
        else
            BWsavedtable['openbank'] = false
        end
    end)
    return checkbox
end

function B.C.openplayercheckbox(parent)

    local checkbox = CreateFrame("CheckButton", "BWopenplayercheckbox", parent, "InterfaceOptionsCheckButtonTemplate")
    checkbox:SetPoint("TOPLEFT", 23, -320)
    checkbox:SetHitRectInsets(0, -300, 0, 0)
    BWopenplayercheckboxText:SetText(L[10037])
    checkbox:SetChecked(BWsavedtable['openplayer'] or false)
    checkbox:SetScript("OnClick", function(self) 
        if self:GetChecked() then
            BWsavedtable['openplayer'] = true
        else
            BWsavedtable['openplayer'] = false
        end
    end)
    return checkbox
end

function B.C.colorselect(parent)

    local colorbox = CreateFrame("Frame", nil, parent)
    colorbox:SetAllPoints()
    colorbox:SetPoint("TOPLEFT", 25, -345)

    B.C.ColorBank.Create(colorbox, 1)
    B.C.ColorReagent.Create(colorbox, 2)
    B.C.ColorCharacter.Create(colorbox, 3)
    B.C.ColorVoid.Create(colorbox, 4)
    B.C.ColorGuild.Create(colorbox, 5)

    B.C.ColorTooltip.Create(colorbox, 1)
    B.C.ColorTooltipAccent.Create(colorbox, 2)

    return colorbox
end

B.C.ColorButton = {}
function B.C.ColorButton.Create(parent, name)

    local button = CreateFrame("Button", name, parent)
    button:SetWidth(21)
    button:SetHeight(21)

    B.I.Backdrop(button)
    button:SetBackdropBorderColor(1, 1, 1, 0.3)

    return button
end

B.C.ColorLabel = {}
function B.C.ColorLabel.Create(parent)

    local editbox = CreateFrame("EditBox", nil, parent, "InputBoxTemplate")

    editbox:SetPoint("TOPLEFT", parent, "TOPRIGHT", 15, 0)
    editbox:SetAutoFocus(false)
    editbox:SetMultiLine(true) -- make text show up
    editbox:SetTextColor(1, 1, 1, 1)
    editbox:SetTextInsets(5, 5, 4, 4)
    editbox:SetWidth(30)

    B.I.RemoveEdge(editbox)
    B.I.Backdrop(editbox)
    editbox:SetBackdropBorderColor(1, 1, 1, 0.3)

    parent.editbox = editbox
    return editbox
end

function B.C.GetColor(restore)
    local r, g, b, a

    if restore then
        r, g, b, a = unpack(restore)
    else
        a, r, g, b = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB()
    end

    return r, g, b, a
end

B.C.ColorBank = {}
function B.C.ColorBank.Create(parent, index)

    local button = B.C.ColorButton.Create(parent, "BWbankcoloroption")
    button:SetPoint("TOPLEFT", 0, -button:GetHeight() * index)
    button:SetBackdropColor(T.BANKTAB.r, T.BANKTAB.g, T.BANKTAB.b, T.BANKTAB.a)
    button:SetScript("OnClick", B.C.ColorBank.Click)
    parent.colorbank = button

    local label = B.C.ColorLabel.Create(button)
    label:SetHeight(button:GetHeight())
    label:SetMaxLetters(1)
    label:SetText(T.LABEL['bank'])
    label:SetScript("OnTextChanged", B.C.ColorBank.TextChanged)
end

function B.C.ColorBank:TextChanged(userInput)
    local text = self:GetText()
    text = text ~= "" and false or self:GetText()

    if userInput and text then
        T.LABEL['bank'] = text
        T.F.mainframe.bankbutton:SetText("|cffffffff"..text.."|r")
        BWsavedtable['colorbanklabel'] = text
    end
end

function B.C.ColorBank:Click(...)
    local r, g, b, a = self:GetBackdropColor()
    B.I.ColorPicker.Create(r, g, b, a, B.C.ColorBank.ColorChanged)
end

function B.C.ColorBank.ColorChanged(restore)
    local r, g, b, a = B.C.GetColor(restore)
    -- Update
    T.F.mainframe.bankbutton:SetBackdropColor(r, g, b, a)
    _G['BWbankcoloroption']:SetBackdropColor(r, g, b, a)
    BWsavedtable['colorbank'] = {r, g, b, a}
    T.BANKTAB.r = r; T.BANKTAB.g = g; T.BANKTAB.b = b; T.BANKTAB.a = a
end

B.C.ColorReagent = {}
function B.C.ColorReagent.Create(parent, index)

    local button = B.C.ColorButton.Create(parent, "BWreagentcoloroption")
    button:SetPoint("TOPLEFT", 0, -button:GetHeight() * index)
    button:SetBackdropColor(T.REAGENTTAB.r, T.REAGENTTAB.g, T.REAGENTTAB.b, T.REAGENTTAB.a)
    button:SetScript("OnClick", B.C.ColorReagent.Click)
    parent.colorreagent = button

    local label = B.C.ColorLabel.Create(button)
    label:SetHeight(button:GetHeight())
    label:SetMaxLetters(1)
    label:SetText(T.LABEL['reagent'])
    label:SetScript("OnTextChanged", B.C.ColorReagent.TextChanged)
end

function B.C.ColorReagent:TextChanged(userInput)
    local text = self:GetText()
    text = text ~= "" and false or self:GetText()

    if userInput and text then
        T.LABEL['reagent'] = text
        T.F.mainframe.reagentbutton:SetText("|cffffffff"..text.."|r")
        BWsavedtable['colorreagentlabel'] = text
    end
end

function B.C.ColorReagent:Click(...)
    local r, g, b, a = self:GetBackdropColor()
    B.I.ColorPicker.Create(r, g, b, a, B.C.ColorReagent.ColorChanged)
end

function B.C.ColorReagent.ColorChanged(restore)
    local r, g, b, a = B.C.GetColor(restore)
    -- Update
    T.F.mainframe.reagentbutton:SetBackdropColor(r, g, b, a)
    _G['BWreagentcoloroption']:SetBackdropColor(r, g, b, a)
    BWsavedtable['colorreagent'] = {r, g, b, a}
    T.REAGENTTAB.r = r; T.REAGENTTAB.g = g; T.REAGENTTAB.b = b; T.REAGENTTAB.a = a
end

B.C.ColorCharacter = {}
function B.C.ColorCharacter.Create(parent, index)

    local button = B.C.ColorButton.Create(parent, "BWcharactercoloroption")
    button:SetPoint("TOPLEFT", 0, -button:GetHeight() * index)
    button:SetBackdropColor(T.CHARTAB.r, T.CHARTAB.g, T.CHARTAB.b, T.CHARTAB.a)
    button:SetScript("OnClick", B.C.ColorCharacter.Click)
    parent.colorcharacter = button

    local label = B.C.ColorLabel.Create(button)
    label:SetHeight(button:GetHeight())
    label:SetMaxLetters(1)
    label:SetText(T.LABEL['player'])
    label:SetScript("OnTextChanged", B.C.ColorCharacter.TextChanged)
end

function B.C.ColorCharacter:TextChanged(userInput)
    local text = self:GetText()
    text = text ~= "" and false or self:GetText()

    if userInput and text then
        T.LABEL['player'] = text
        T.F.mainframe.characterbutton:SetText("|cffffffff"..text.."|r")
        BWsavedtable['colorcharacterlabel'] = text
    end
end

function B.C.ColorCharacter:Click(...)
    local r, g, b, a = self:GetBackdropColor()
    B.I.ColorPicker.Create(r, g, b, a, B.C.ColorCharacter.ColorChanged)
end

function B.C.ColorCharacter.ColorChanged(restore)
    local r, g, b, a = B.C.GetColor(restore)
    -- Update
    T.F.mainframe.characterbutton:SetBackdropColor(r, g, b, a)
    _G['BWcharactercoloroption']:SetBackdropColor(r, g, b, a)
    BWsavedtable['colorcharacter'] = {r, g, b, a}
    T.CHARTAB.r = r; T.CHARTAB.g = g; T.CHARTAB.b = b; T.CHARTAB.a = a
end

B.C.ColorVoid = {}
function B.C.ColorVoid.Create(parent, index)

    local button = B.C.ColorButton.Create(parent, "BWvoidcoloroption")
    button:SetPoint("TOPLEFT", 0, -button:GetHeight() * index)
    button:SetBackdropColor(T.VOIDTAB.r, T.VOIDTAB.g, T.VOIDTAB.b, T.VOIDTAB.a)
    button:SetScript("OnClick", B.C.ColorVoid.Click)
    parent.colorvoid = button

    local label = B.C.ColorLabel.Create(button)
    label:SetHeight(button:GetHeight())
    label:SetMaxLetters(1)
    label:SetText(T.LABEL['void'])
    label:SetScript("OnTextChanged", B.C.ColorVoid.TextChanged)
end

function B.C.ColorVoid:TextChanged(userInput)
    local text = self:GetText()
    text = text ~= "" and false or self:GetText()

    if userInput and text then
        T.LABEL['void'] = text
        T.F.mainframe.voidbutton:SetText("|cffffffff"..text.."|r")
        BWsavedtable['colorvoidlabel'] = text
    end
end

function B.C.ColorVoid:Click(...)
    local r, g, b, a = self:GetBackdropColor()
    B.I.ColorPicker.Create(r, g, b, a, B.C.ColorVoid.ColorChanged)
end

function B.C.ColorVoid.ColorChanged(restore)
    local r, g, b, a = B.C.GetColor(restore)
    -- Update
    T.F.mainframe.voidbutton:SetBackdropColor(r, g, b, a)
    _G['BWvoidcoloroption']:SetBackdropColor(r, g, b, a)
    BWsavedtable['colorvoid'] = {r, g, b, a}
    T.VOIDTAB.r = r; T.VOIDTAB.g = g; T.VOIDTAB.b = b; T.VOIDTAB.a = a
end

B.C.ColorGuild = {}
function B.C.ColorGuild.Create(parent, index)

    local button = B.C.ColorButton.Create(parent, "BWguildcoloroption")
    button:SetPoint("TOPLEFT", 0, -button:GetHeight() * index)
    button:SetBackdropColor(T.GUILDTAB.r, T.GUILDTAB.g, T.GUILDTAB.b, T.GUILDTAB.a)
    button:SetScript("OnClick", B.C.ColorGuild.Click)
    parent.colorguild = button

    local label = B.C.ColorLabel.Create(button)
    label:SetHeight(button:GetHeight())
    label:SetMaxLetters(1)
    label:SetText(T.LABEL['guild'])
    label:SetScript("OnTextChanged", B.C.ColorGuild.TextChanged)
end

function B.C.ColorGuild:TextChanged(userInput)
    local text = self:GetText()
    text = text ~= "" and false or self:GetText()

    if userInput and text then
        T.LABEL['guild'] = text
        T.F.mainframe.guildbutton:SetText("|cffffffff"..text.."|r")
        BWsavedtable['colorguildlabel'] = text
    end
end

function B.C.ColorGuild:Click(...)
    local r, g, b, a = self:GetBackdropColor()
    B.I.ColorPicker.Create(r, g, b, a, B.C.ColorGuild.ColorChanged)
end

function B.C.ColorGuild.ColorChanged(restore)
    local r, g, b, a = B.C.GetColor(restore)
    -- Update
    T.F.mainframe.guildbutton:SetBackdropColor(r, g, b, a)
    _G['BWguildcoloroption']:SetBackdropColor(r, g, b, a)
    BWsavedtable['colorguild'] = {r, g, b, a}
    T.GUILDTAB.r = r; T.GUILDTAB.g = g; T.GUILDTAB.b = b; T.GUILDTAB.a = a
end

B.C.ColorTooltip = {}
function B.C.ColorTooltip.Create(parent, index)

    local button = B.C.ColorButton.Create(parent, "BWtooltipcoloroption")
    button:SetPoint("TOPLEFT", 120, -button:GetHeight() * index)
    button:SetBackdropColor(T.TOOLTIP.r, T.TOOLTIP.g, T.TOOLTIP.b, 1)
    button:SetScript("OnClick", B.C.ColorTooltip.Click)
    parent.colortooltip = button

    local label = button:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    label:SetText("|cffffffff"..L[10034].."|r")
    label:SetPoint("LEFT", 30, 0)
    button.label = label
end

function B.C.ColorTooltip:Click(...)
    local r, g, b, a = self:GetBackdropColor()
    B.I.ColorPicker.Create(r, g, b, a, B.C.ColorTooltip.ColorChanged)
end

function B.C.ColorTooltip.ColorChanged(restore)
    local r, g, b = B.C.GetColor(restore)
    -- Update
    _G['BWtooltipcoloroption']:SetBackdropColor(r, g, b, 1)
    BWsavedtable['colortooltip'] = {r, g, b, 1}
    T.TOOLTIP.r = r; T.TOOLTIP.g = g; T.TOOLTIP.b = b;
end

B.C.ColorTooltipAccent = {}
function B.C.ColorTooltipAccent.Create(parent, index)

    local button = B.C.ColorButton.Create(parent, "BWtooltipaccentcoloroption")
    button:SetPoint("TOPLEFT", 120, -button:GetHeight() * index)
    button:SetBackdropColor(T.TOOLTIPAC.r, T.TOOLTIPAC.g, T.TOOLTIPAC.b, 1)
    button:SetScript("OnClick", B.C.ColorTooltipAccent.Click)
    parent.colortooltipaccent = button

    local label = button:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    label:SetText("|cffffffff"..L[10035].."|r")
    label:SetPoint("LEFT", 30, 0)
    button.label = label
end

function B.C.ColorTooltipAccent:Click(...)
    local r, g, b, a = self:GetBackdropColor()
    B.I.ColorPicker.Create(r, g, b, a, B.C.ColorTooltipAccent.ColorChanged)
end

function B.C.ColorTooltipAccent.ColorChanged(restore)
    local r, g, b = B.C.GetColor(restore)
    -- Update
    _G['BWtooltipaccentcoloroption']:SetBackdropColor(r, g, b, 1)
    BWsavedtable['colortooltipaccent'] = {r, g, b, 1}
    T.TOOLTIPAC.r = r; T.TOOLTIPAC.g = g; T.TOOLTIPAC.b = b;
end
